﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using GalaSoft.MvvmLight.Command;
using GalaSoft.MvvmLight.Messaging;

namespace ASPItalia.Books.AppendixA.ViewModels
{
	public class MainPageViewModel : ViewModelBase
	{
		public MainPageViewModel()
			: base()
		{
			SearchCommand = new RelayCommand(Search, () => !this.IsLoading);
			
		}

		public ICommand SearchCommand { get; private set; }

		public void Search()
		{
			// simulo una ricerca
			IsLoading = true;

			// invio un comando
			Messenger.Default.Send(new DialogMessage("Test messaggio!", (MessageBoxResult r) =>
			{
				// gestisco la risposta
			}));
		}

		private bool _isLoading;
		public bool IsLoading
		{
			get { return _isLoading; }
			private set
			{
				_isLoading = value;
				OnPropertyChanged("IsLoading");
			}
		}
	}
}
