﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Threading;

namespace ASPItalia.Books.Chapter4
{
    public partial class Page_4_22 : PhoneApplicationPage
    {
        private Timer timer;

        public Page_4_22()
        {
            InitializeComponent();

            this.player.Source = new Uri("http://media.aspitalia.com/screencast/Windows-Phone-7-prova-su-strada.mp4");
            updateState();

            timer = new Timer(
                (o) => updateTimeline(), null, 0, 1000);
        }

        private void updateTimeline()
        {
            if (this.player.NaturalDuration.TimeSpan.Seconds > 0)
            {
                string timeText = string.Format("{0}:{1:00}/{2}:{3:00}",
                    this.player.Position.Minutes,
                    this.player.Position.Seconds,
                    this.player.NaturalDuration.TimeSpan.Minutes,
                    this.player.NaturalDuration.TimeSpan.Seconds
                );

                double timeValue =
                    this.player.Position.TotalSeconds /
                    this.player.NaturalDuration.TimeSpan.TotalSeconds;

                Dispatcher.BeginInvoke(() =>
                {
                    this.timeLine.Value = timeValue;
                    this.timeLabel.Text = timeText;
                });

            }
        }

        private void Rewind(object sender, RoutedEventArgs e)
        {
            this.player.Position = TimeSpan.FromSeconds(0);
        }

        private void Play(object sender, RoutedEventArgs e)
        {
            this.player.Play();
        }

        private void Pause(object sender, RoutedEventArgs e)
        {
            if (this.player.CurrentState == MediaElementState.Playing)
                this.player.Pause();
            else if (this.player.CurrentState == MediaElementState.Paused)
                this.player.Play();
        }

        private void FastForward(object sender, RoutedEventArgs e)
        {
            var nextPosition = this.player.Position + TimeSpan.FromSeconds(30);
            if (nextPosition > this.player.NaturalDuration.TimeSpan)
                nextPosition = this.player.NaturalDuration.TimeSpan;

            this.player.Position = nextPosition;
        }

        private void player_CurrentStateChanged(object sender, RoutedEventArgs e)
        {
            updateState();
        }

        private void player_BufferingProgressChanged(object sender, RoutedEventArgs e)
        {
            updateState();
        }

        private void updateState()
        {
            this.statusLabel.Text = string.Format("{0} - Buffering: {1:0}%",
                this.player.CurrentState, this.player.BufferingProgress * 100);
        }
    }
}