﻿Imports System.Threading

Partial Public Class Page_4_22
    Inherits PhoneApplicationPage

    Private timer As Timer

    Public Sub New()
        InitializeComponent()
        timer = New Timer(Sub(o) UpdateTimeline(), Nothing, 0, 1000)
    End Sub

    Private Sub Play(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Me.player.Play()
    End Sub

    Private Sub Pause(ByVal sender As Object, ByVal e As RoutedEventArgs)
        If Me.player.CurrentState = MediaElementState.Playing Then
            Me.player.Pause()
        ElseIf Me.player.CurrentState = MediaElementState.Paused Then
            Me.player.Play()
        End If
    End Sub

    Private Sub Rewind(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Me.player.Position = TimeSpan.FromSeconds(0)
    End Sub

    Private Sub FastForward(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim nextPosition = Me.player.Position + TimeSpan.FromSeconds(30)
        If nextPosition > Me.player.NaturalDuration.TimeSpan Then
            nextPosition = Me.player.NaturalDuration.TimeSpan
        End If

        Me.player.Position = nextPosition
    End Sub

    Private Sub CurrentStateChanged(ByVal sender As Object, ByVal e As RoutedEventArgs)
        UpdateState()
    End Sub

    Private Sub BufferingProgressChanged(ByVal sender As Object,
      ByVal e As RoutedEventArgs)

        UpdateState()
    End Sub

    Private Sub UpdateState()
        ' Visualizzazione di stato player e percentuale di buffering
        Me.statusLabel.Text = String.Format("{0} - Buffering: {1:0}%",
          Me.player.CurrentState, Me.player.BufferingProgress * 100)
    End Sub

    Private Sub UpdateTimeline()
        If Me.player.NaturalDuration.TimeSpan.Seconds > 0 Then
            Dim timeText As String = String.Format("{0}:{1:00}/{2}:{3:00}",
              Me.player.Position.Minutes, Me.player.Position.Seconds,
              Me.player.NaturalDuration.TimeSpan.Minutes,
              Me.player.NaturalDuration.TimeSpan.Seconds)

            Dim timeValue As Double =
              Me.player.Position.TotalSeconds /
              Me.player.NaturalDuration.TimeSpan.TotalSeconds

            Dispatcher.BeginInvoke(
              Sub()
                  Me.timeLine.Value = timeValue
                  Me.timeLabel.Text = timeText
              End Sub)
        End If
    End Sub

End Class
