﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace ASPItalia.Books.Chapter6
{
	public partial class Orientation2 : PhoneApplicationPage
	{
		public Orientation2()
		{
			InitializeComponent();

			this.OrientationChanged +=
			delegate(object sender, OrientationChangedEventArgs e)
			{
				// ricaviamo in che modalità ci troviamo
				bool isPortrait = e.Orientation == PageOrientation.Portrait ||
								e.Orientation == PageOrientation.PortraitUp ||
								e.Orientation == PageOrientation.PortraitDown;

				int columnIndex = isPortrait ? 0 : 1;
				int rowIndex = isPortrait ? 1 : 0;

				// impostiamo colonna e riga corrente per ToolBox
				Grid.SetColumn(ToolBox, columnIndex);
				Grid.SetRow(ToolBox, rowIndex);

				// gestiamo in maniera programmatica la dimensione della colonna
				ContentPanel.ColumnDefinitions[0].Width = isPortrait ?
								new GridLength(0, GridUnitType.Auto) :
								new GridLength(700, GridUnitType.Star);
			};

		}

	}
}