﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.IO;
using System.Xml.Linq;

namespace ASPItalia.Books.Chapter07
{
    public partial class WebRequestsPage : PhoneApplicationPage
    {
        public WebRequestsPage()
        {
            InitializeComponent();
        }

        private WebClient client;
        private HttpWebRequest request;

        protected override void OnNavigatedFrom(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedFrom(e);

            // Annullo la richiesta attualmente in corso
            if (client != null)
                client.CancelAsync();
            if (request != null)
                request.Abort();
        }

        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);

            // Richiesta alla risorsa
            client = new WebClient();
            client.OpenReadCompleted += new OpenReadCompletedEventHandler(client_OpenReadCompleted);
            client.OpenReadAsync(new Uri("http://www.aspitalia.com"));

            request = WebRequest.CreateHttp(new Uri("http://feed.aspitalia.com/feed.xml"));
            request.BeginGetResponse(OnGetResponse, null);
        }

        private void OnGetResponse(IAsyncResult ar)
        {
            // Ottengo la risposta
            HttpWebResponse response;
            try
            {
                response = (HttpWebResponse)request.EndGetResponse(ar);
            }
            catch (WebException we)
            {
                return;
            }

            // Ottengo lo Stream della risposta
            using (Stream result = response.GetResponseStream())
            {
                // Cerco il titolo
                string title = XElement.Load(result).Descendants("title").First().Value;

                // Accordo sullo UI thread
                this.Dispatcher.BeginInvoke(() => this.ApplicationTitle.Text = title);
            }
        }

        void client_OpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {

        }
    }
}