﻿Imports System.Collections.Generic
Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports Microsoft.Phone.Controls
Imports ASPItalia.Books.Chapter07.Components
Imports System.Threading
Imports System.Diagnostics


Partial Public Class VirtualPage
    Inherits PhoneApplicationPage

    Private list As VirtualList(Of Product)
    Private imagesUri As Uri()

    Public Sub New()
        InitializeComponent()

        ' Preparo la lista virtuale
        Me.list = New VirtualList(Of Product)(Product.LoadItem)
        AddHandler Me.list.ItemsNeeded, AddressOf list_ItemsNeeded

        ' Associo la lista alla ListBox
        Me.listBox.ItemsSource = Me.list

        Me.imagesUri = New Uri() {
            New Uri("http://books.aspitalia.com/Windows-Phone/cover.jpg"),
            New Uri("http://books.aspitalia.com/ASP.NET-4.0/cover.jpg"),
            New Uri("http://books.aspitalia.com/VisualBasic-2010/cover.jpg"),
            New Uri("http://books.aspitalia.com/ASP.NET-4.0-in-practice/cover.jpg"),
            New Uri("http://books.aspitalia.com/CSharp-4/cover.jpg"),
            New Uri("http://books.aspitalia.com/Entity-Framework/cover.jpg"),
            New Uri("http://books.aspitalia.com/CSharp-4-Guida-Professionale/cover.jpg"),
            New Uri("http://books.aspitalia.com/ASP.NET-4-Guida-Professionale/cover.jpg"),
            New Uri("http://books.aspitalia.com/Silverlight-3.0/cover.jpg"),
            New Uri("http://books.aspitalia.com/ASP.NET-3.5/cover.jpg"),
            New Uri("http://books.aspitalia.com/ASP.NET-2.0/cover.jpg"),
            New Uri("http://books.aspitalia.com/ASP-3-per-esempi/cover.jpg")}
    End Sub

    Private Sub list_ItemsNeeded(ByVal sender As Object, ByVal e As ItemsNeededEventArgs)
        Debug.WriteLine("Asked items from {0}", e.StartIndex)

        ' Carico in asincrono, per non pesare sulla UI
        ThreadPool.QueueUserWorkItem(Sub(c) LoadNextChunk(e.StartIndex))
    End Sub

    Private Sub LoadNextChunk(ByVal index As Integer)
        ' Finta pausa di caricamento
        System.Threading.Thread.Sleep(2000)

        Dim random As New Random(Environment.TickCount)
        ' Preparo dei dati fittizzi da caricare
        Dim newItems = Enumerable.Range(index + 1, 30).[Select](Function(r) New Product() With { _
         .Description = "Prodotto " & Convert.ToString(r), _
         .Quantity = random.[Next](0, 50), _
         .Image = imagesUri(random.[Next](0, imagesUri.Length - 1)) _
        }).ToArray()

        ' Aggiungo gli elementi (sul thread UI, importante)
        Me.Dispatcher.BeginInvoke(Sub() Me.list.AddRange(newItems))
    End Sub

End Class