﻿Imports System.Collections.Generic
Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports Microsoft.Phone.Controls
Imports System.IO
Imports System.Xml.Linq

Partial Public Class WebRequestsPage
    Inherits PhoneApplicationPage
    Public Sub New()
        InitializeComponent()
    End Sub

    Private client As WebClient
    Private request As HttpWebRequest

    Protected Overrides Sub OnNavigatedFrom(ByVal e As System.Windows.Navigation.NavigationEventArgs)
        MyBase.OnNavigatedFrom(e)

        ' Annullo la richiesta attualmente in corso
        If client IsNot Nothing Then
            client.CancelAsync()
        End If
        If request IsNot Nothing Then
            request.Abort()
        End If
    End Sub

    Protected Overrides Sub OnNavigatedTo(ByVal e As System.Windows.Navigation.NavigationEventArgs)
        MyBase.OnNavigatedTo(e)

        ' Richiesta alla risorsa
        client = New WebClient()
        AddHandler client.OpenReadCompleted, New OpenReadCompletedEventHandler(AddressOf client_OpenReadCompleted)
        client.OpenReadAsync(New Uri("http://www.aspitalia.com"))

        request = WebRequest.CreateHttp(New Uri("http://feed.aspitalia.com/feed.xml"))
        request.BeginGetResponse(AddressOf OnGetResponse, Nothing)
    End Sub

    Private Sub OnGetResponse(ByVal ar As IAsyncResult)
        ' Ottengo la risposta
        Dim response As HttpWebResponse
        Try
            response = DirectCast(request.EndGetResponse(ar), HttpWebResponse)
        Catch we As WebException
            Return
        End Try

        ' Ottengo lo Stream della risposta
        Using result As Stream = response.GetResponseStream()
            ' Cerco il titolo
            Dim title As String = XElement.Load(result).Descendants("title").First().Value

            ' Accordo sullo UI thread
            Me.Dispatcher.BeginInvoke(Function() InlineAssignHelper(Me.ApplicationTitle.Text, title))
        End Using
    End Sub

    Private Sub client_OpenReadCompleted(ByVal sender As Object, ByVal e As OpenReadCompletedEventArgs)

    End Sub
    Private Shared Function InlineAssignHelper(Of T)(ByRef target As T, ByVal value As T) As T
        target = value
        Return value
    End Function
End Class