﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Tasks;
using System.IO.IsolatedStorage;
using System.Xml.Serialization;
using System.Diagnostics;

namespace ASPItalia.Books.Chapter8
{
  public partial class MainPage : PhoneApplicationPage
  {
    public MainPage()
    {
      InitializeComponent();

      Debug.WriteLine("costruttore MainPage");
    }

    protected override void OnNavigatedFrom(System.Windows.Navigation.NavigationEventArgs e)
    {
      if (State.ContainsKey("FocusedElement"))
        State.Remove("FocusedElement");

      object focusedObj = FocusManager.GetFocusedElement();
      if (null != focusedObj)
      {
        string focusedControlName = (focusedObj as FrameworkElement).Name;
        State.Add("FocusedElement", focusedControlName);
      }

      base.OnNavigatedFrom(e);
    }

    protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
    {
      if (State.ContainsKey("FocusedElement"))
      {
        Control focusedElement = this.FindName(State["FocusedElement"] as string) as Control;

        if (focusedElement != null)
          focusedElement.Focus();
      }

      base.OnNavigatedTo(e);
    }

    private void Button1_Click(object sender, RoutedEventArgs e)
    {
      MainData _mainData = (Application.Current.RootVisual as PhoneApplicationFrame).DataContext as MainData;
      _mainData.AllNotes.Add(new Note() { Text = _mainData.CurrentNote.Text, IsSpecial = _mainData.CurrentNote.IsSpecial });
      _mainData.CurrentNote = null;

      using (IsolatedStorageFile isf = IsolatedStorageFile.GetUserStoreForApplication())
      {
        using (IsolatedStorageFileStream fs = isf.CreateFile(MainData.STORAGE_FILENAME))
        {
          XmlSerializer ser = new XmlSerializer(typeof(MainData));
          ser.Serialize(fs, _mainData);
        }
      }
    }

    private void Button2_Click(object sender, RoutedEventArgs e)
    {
      NavigationService.Navigate(new Uri("/SecondPage.xaml", UriKind.Relative));
    }

    private void Button3_Click(object sender, RoutedEventArgs e)
    {
      SmsComposeTask smsTask = new SmsComposeTask();
      smsTask.Show();
    }

    private void Button4_Click(object sender, RoutedEventArgs e)
    {
      object test = string.Empty;
      int i = (int)test;
    }
  }
}