﻿Imports System.Windows.Data
Imports System.ComponentModel

Partial Public Class SecondPage
  Inherits PhoneApplicationPage

  Private _viewSource As CollectionViewSource

  Public Sub New()
    InitializeComponent()
  End Sub

  Private Sub LoadData()
    If (Me._viewSource Is Nothing) Then
      Me._viewSource = New CollectionViewSource
      Dim _mainData As MainData = TryCast(TryCast(Application.Current.RootVisual, PhoneApplicationFrame).DataContext, MainData)
      If (Not _mainData Is Nothing) Then
        Me._viewSource.Source = _mainData.AllNotes
        Dim collectionView As ICollectionView = Me._viewSource.View
        collectionView.Filter = Function(n) DirectCast(n, Note).IsSpecial = viewOnlySpecial.IsChecked.Value
        Me.NotesList.ItemsSource = collectionView
      End If
    End If
  End Sub

  Protected Overrides Sub OnNavigatedFrom(ByVal e As NavigationEventArgs)
    If MyBase.State.ContainsKey("viewOnlySpecial") Then
      MyBase.State.Remove("viewOnlySpecial")
    End If
    MyBase.State.Add("viewOnlySpecial", Me.viewOnlySpecial.IsChecked)
    MyBase.OnNavigatedFrom(e)
  End Sub

  Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)
    Me.LoadData()
    If MyBase.State.ContainsKey("viewOnlySpecial") Then
      Me.viewOnlySpecial.IsChecked = DirectCast(State("viewOnlySpecial"), Boolean?)
    End If
    MyBase.OnNavigatedTo(e)
  End Sub

  Private Sub viewOnlySpecial_Checked(ByVal sender As Object, ByVal e As RoutedEventArgs)
    If (Not Me._viewSource Is Nothing) Then
      Me._viewSource.View.Refresh()
    End If
  End Sub

  Private Sub viewOnlySpecial_Unchecked(ByVal sender As Object, ByVal e As RoutedEventArgs)
    If (Not Me._viewSource Is Nothing) Then
      Me._viewSource.View.Refresh()
    End If
  End Sub

End Class
