using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GameStateManagement;
using Microsoft.Xna.Framework;

namespace XNABookGame.Screen
{
    class MainMenuScreen : MenuScreen
    {
        public MainMenuScreen()
            : base("Main Menu")
        {
            MenuEntry playGameMenuEntry = new MenuEntry("Play");
            MenuEntry optionsMenuEntry = new MenuEntry("Options");
            MenuEntry multyPlayerMenuEntry = new MenuEntry("Multyplayer");

            playGameMenuEntry.Selected += PlayNewGame;
            MenuEntries.Add(playGameMenuEntry);
            MenuEntries.Add(optionsMenuEntry);
            MenuEntries.Add(multyPlayerMenuEntry);
        }

        void PlayNewGame(object sender, PlayerIndexEventArgs e)
        {
            //Set second argument to true if loading level i slow
            LoadingScreen.Load(ScreenManager, false, e.PlayerIndex, new GameplayScreen());
        }

        protected override void OnCancel(PlayerIndex playerIndex)
        {
            ScreenManager.Game.Exit();
        }
    }
}
