using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;
using GameStateManagement;
using XNABookGame.Screen;

namespace XNABookGame
{
  /// <summary>
  /// This is the main type for your game
  /// </summary>
  public class XnabookGame : Microsoft.Xna.Framework.Game
  {
    GraphicsDeviceManager graphics;
    ScreenManager screenManager;

public XnabookGame()
{
  graphics = new GraphicsDeviceManager(this);
  graphics.IsFullScreen = true;
  graphics.PreferredBackBufferWidth = 480;
  graphics.PreferredBackBufferHeight = 800;
  Content.RootDirectory = "Content";
  TargetElapsedTime = TimeSpan.FromTicks(333333);
  screenManager = new ScreenManager(this);
  Components.Add(screenManager);
  if (!screenManager.DeserializeState())
  {
    screenManager.AddScreen(new MainMenuScreen(), null);
  }
}

    /// <summary>
    /// Allows the game to perform any initialization it needs to before starting to run.
    /// This is where it can query for any required services and load any non-graphic
    /// related content.  Calling base.Initialize will enumerate through any components
    /// and initialize them as well.
    /// </summary>
    protected override void Initialize()
    {
      // TODO: Add your initialization logic here
      base.Initialize();
    }


    /// <summary>
    /// UnloadContent will be called once per game and is the place to unload
    /// all content.
    /// </summary>
    protected override void UnloadContent()
    {
      // TODO: Unload any non ContentManager content here
    }

    /// <summary>
    /// Allows the game to run logic such as updating the world,
    /// checking for collisions, gathering input, and playing audio.
    /// </summary>
    /// <param name="gameTime">Provides a snapshot of timing values.</param>
    protected override void Update(GameTime gameTime)
    {
      // Allows the game to exit
      //if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
      //    this.Exit();

      // TODO: Add your update logic here

      base.Update(gameTime);
    }

    /// <summary>
    /// This is called when the game should draw itself.
    /// </summary>
    /// <param name="gameTime">Provides a snapshot of timing values.</param>
    protected override void Draw(GameTime gameTime)
    {
      GraphicsDevice.Clear(Color.CornflowerBlue);

      // TODO: Add your drawing code here

      base.Draw(gameTime);
    }
  }
}
