﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Devices.Sensors;

namespace ASPItalia.Books.Chapter12
{
    public partial class AccelerometerDemo : PhoneApplicationPage
    {
        public AccelerometerDemo()
        {
            InitializeComponent();

            var accelerometer = new Accelerometer();
            accelerometer.ReadingChanged += accelerometer_ReadingChanged;

            accelerometer.Start();
        }

        private double minMagnitude = double.MaxValue;
        private double maxMagnitude = double.MinValue;

        private void accelerometer_ReadingChanged(object sender, AccelerometerReadingEventArgs e)
        {
            var magnitude = Math.Sqrt(
                Math.Pow(e.X, 2) +
                Math.Pow(e.Y, 2) +
                Math.Pow(e.Z, 2));

            if (minMagnitude > magnitude)
                minMagnitude = magnitude;
            if (maxMagnitude < magnitude)
                maxMagnitude = magnitude;

            string text = string.Format(
                "X: {0:0.###}\nY: {1:0.###}\nZ: {2:0.###}\n\n" +
            "Current Acceleration: {3:0.###}\nMin Acceleration: {4:0.###}\nMax Acceleration: {5:0.###}",
            e.X, e.Y, e.Z, magnitude, minMagnitude, maxMagnitude);

            bool moving = Math.Abs(magnitude - 1) > .04;

            this.Dispatcher.BeginInvoke(() =>
            {
                this.textBlock.Text = text;
                if (moving)
                {
                    this.textIsMoving.Foreground = new SolidColorBrush(Colors.Red);
                    this.textIsMoving.Text = "In movimento";
                }
                else
                {
                    this.textIsMoving.Foreground = new SolidColorBrush(Colors.Green);
                    this.textIsMoving.Text = "Fermo";
                }
            });
        }
    }
}