﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Device.Location;

namespace ASPItalia.Books.Chapter12
{
    public partial class LocationDemo : PhoneApplicationPage
    {
        public LocationDemo()
        {
            InitializeComponent();

            this.Loaded += new RoutedEventHandler(LocationDemo_Loaded);
        }

        void LocationDemo_Loaded(object sender, RoutedEventArgs e)
        {
            GeoCoordinateWatcher watcher = new GeoCoordinateWatcher
                (GeoPositionAccuracy.High);

            this.txtStatus.Text = watcher.Status.ToString();

            watcher.StatusChanged +=
                (s, ev) => this.txtStatus.Text = ev.Status.ToString();

            watcher.PositionChanged += new EventHandler<GeoPositionChangedEventArgs<GeoCoordinate>>(watcher_PositionChanged);

            if (!watcher.TryStart(true, TimeSpan.FromSeconds(5)))
            {
                MessageBox.Show("Attivare il GPS dalle opzioni");
            }
        }

        GeoCoordinate currentLocation;
        void watcher_PositionChanged(object sender, GeoPositionChangedEventArgs<GeoCoordinate> e)
        {
            this.currentLocation = e.Position.Location;
            if (this.btnCenter.IsChecked == true)
            {
                zoomToCurrentLocation();

            }
        }

        private void zoomToCurrentLocation()
        {
            if (this.currentLocation == null)
                return;

            var accuracy =
                    Math.Max(currentLocation.HorizontalAccuracy,
                    currentLocation.VerticalAccuracy);

            double zoomLevel;
            if (accuracy > 200)
                zoomLevel = 13;
            else if (accuracy > 50)
                zoomLevel = 15;
            else if (accuracy > 20)
                zoomLevel = 16;
            else
                zoomLevel = 17;

            this.map.SetView(currentLocation, zoomLevel);

            this.txtStatus.Text = zoomLevel.ToString();
        }

        private void btnCenter_Click(object sender, RoutedEventArgs e)
        {
            if (btnCenter.IsChecked == true)
                zoomToCurrentLocation();
        }
    }
}