﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace ASPItalia.Books.Chapter12
{
    public partial class ManipulationDemo : PhoneApplicationPage
    {
        public ManipulationDemo()
        {
            InitializeComponent();
        }

        private void Image_ManipulationDelta(object sender, ManipulationDeltaEventArgs e)
        {
            Image element = e.OriginalSource as Image;

            if (element == null)
                return;

            CompositeTransform transform = (CompositeTransform)element.RenderTransform;

            transform.TranslateX += e.DeltaManipulation.Translation.X;
            transform.TranslateY += e.DeltaManipulation.Translation.Y;

            if (e.DeltaManipulation.Scale.X > 0)
                transform.ScaleX *= e.DeltaManipulation.Scale.X;
            if (e.DeltaManipulation.Scale.Y > 0)
                transform.ScaleY *= e.DeltaManipulation.Scale.Y;

            e.Handled = true;
        }

        private void Image_ManipulationStarted(object sender, ManipulationStartedEventArgs e)
        {
            Image element = e.OriginalSource as Image;
            element.Opacity = 0.4;

            if (!(element.RenderTransform is CompositeTransform))
            {
                element.RenderTransform = new CompositeTransform();
                element.RenderTransformOrigin = new Point(0.5, 0.5);
            }

            e.Handled = true;
        }

        private void Image_ManipulationCompleted(object sender, ManipulationCompletedEventArgs e)
        {
            Image element = e.OriginalSource as Image;
            element.Opacity = 1;

            e.Handled = true;
        }
    }
}