﻿Imports Microsoft.Devices.Sensors

Partial Public Class AccelerometerDemo
    Inherits PhoneApplicationPage

    Public Sub New()
        InitializeComponent()

        Dim accelerometer = New Accelerometer()
        AddHandler accelerometer.ReadingChanged,
            AddressOf Me.accelerometer_ReadingChanged

        accelerometer.Start()
    End Sub

    Private minMagnitude As Double = Double.MaxValue
    Private maxMagnitude As Double = Double.MinValue

    Private Sub accelerometer_ReadingChanged(ByVal sender As Object, ByVal e As AccelerometerReadingEventArgs)
        Dim magnitude = Math.Sqrt(
            Math.Pow(e.X, 2) +
            Math.Pow(e.Y, 2) +
            Math.Pow(e.Z, 2))

        If minMagnitude > magnitude Then
            minMagnitude = magnitude
        End If
        If maxMagnitude < magnitude Then
            maxMagnitude = magnitude
        End If

        Dim text = String.Format(
                "X: {0:0.###}" + vbCrLf +
                "Y: {1:0.###}" + vbCrLf +
                "Z: {2:0.###}" + vbCrLf + vbCrLf +
                "Current Acceleration: {3:0.###}" + vbCrLf +
                "Min Acceleration: {4:0.###}" + vbCrLf +
                "Max Acceleration: {5:0.###}",
                 e.X, e.Y, e.Z, magnitude, minMagnitude, maxMagnitude)

        Dim moving As Boolean = Math.Abs(magnitude - 1) > 0.04

        Me.Dispatcher.BeginInvoke(
            Sub()
                Me.textBlock.Text = text
                If moving Then
                    Me.textIsMoving.Foreground = New SolidColorBrush(Colors.Red)
                    Me.textIsMoving.Text = "Moving"
                Else
                    Me.textIsMoving.Foreground = New SolidColorBrush(Colors.Green)
                    Me.textIsMoving.Text = "Not Moving"
                End If
            End Sub)
    End Sub
End Class
