﻿Imports System.Device.Location

Partial Public Class LocationDemo
    Inherits PhoneApplicationPage

    Public Sub New()
        InitializeComponent()

        Dim watcher As New GeoCoordinateWatcher(GeoPositionAccuracy.High)

        Me.txtStatus.Text = watcher.Status.ToString

        AddHandler watcher.StatusChanged, Sub(s, ev) Me.txtStatus.Text = ev.Status.ToString

        AddHandler watcher.PositionChanged, AddressOf Me.watcher_PositionChanged

        If Not watcher.TryStart(True, TimeSpan.FromSeconds(5)) Then
            MessageBox.Show("Attivare il GPS dalle opzioni")
        End If
    End Sub

    Private currentLocation As GeoCoordinate
    Private Sub watcher_PositionChanged(ByVal sender As Object, ByVal e As GeoPositionChangedEventArgs(Of GeoCoordinate))
        Me.currentLocation = e.Position.Location

        If Me.btnCenter.IsChecked = True Then
            zoomToCurrentLocation()
        End If

    End Sub

    Private Sub zoomToCurrentLocation()
        If Me.currentLocation Is Nothing Then
            Return
        End If

        Dim accuracy = Math.Max(
            currentLocation.HorizontalAccuracy,
            currentLocation.VerticalAccuracy)

        Dim zoomLevel As Double
        If accuracy > 200 Then
            zoomLevel = 13
        ElseIf accuracy > 50 Then
            zoomLevel = 15
        ElseIf accuracy > 20 Then
            zoomLevel = 16
        Else
            zoomLevel = 17
        End If

        Me.map.SetView(currentLocation, zoomLevel)

        Me.txtStatus.Text = zoomLevel.ToString

    End Sub

    Private Sub btnCenter_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        If btnCenter.IsChecked = True Then
            zoomToCurrentLocation()
        End If
    End Sub
End Class
