﻿Partial Public Class ManipulationDemo
    Inherits PhoneApplicationPage

    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub Image_ManipulationStarted(ByVal sender As Object, ByVal e As ManipulationStartedEventArgs)
        Dim element As Image = TryCast(e.OriginalSource, Image)

        element.Opacity = 0.4

        If Not element.RenderTransform Is GetType(CompositeTransform) Then
            element.RenderTransform = New CompositeTransform
            element.RenderTransformOrigin = New Point(0.5, 0.5)
        End If

        e.Handled = True
    End Sub

    Private Sub Image_ManipulationDelta(ByVal sender As System.Object, ByVal e As System.Windows.Input.ManipulationDeltaEventArgs)
        Dim element As Image = TryCast(e.OriginalSource, Image)

        If element Is Nothing Then
            Return
        End If

        Dim transform As CompositeTransform =
            DirectCast(element.RenderTransform, CompositeTransform)
        transform.TranslateX += e.DeltaManipulation.Translation.X
        transform.TranslateY += e.DeltaManipulation.Translation.Y

        If e.DeltaManipulation.Scale.X > 0 Then
            transform.ScaleX *= e.DeltaManipulation.Scale.X
        End If
        If e.DeltaManipulation.Scale.Y > 0 Then
            transform.ScaleY *= e.DeltaManipulation.Scale.Y
        End If

        e.Handled = True
    End Sub

    Private Sub Image_ManipulationCompleted(ByVal sender As System.Object, ByVal e As System.Windows.Input.ManipulationCompletedEventArgs)
        Dim element As Image = TryCast(e.OriginalSource, Image)
        element.Opacity = 1
        e.Handled = True
    End Sub

End Class
