﻿Imports System.Collections.ObjectModel

Partial Public Class TouchDemo
    Inherits PhoneApplicationPage

    Public Sub New()
        InitializeComponent()

        AddHandler Touch.FrameReported, AddressOf Touch_FrameReported
    End Sub

    Private Sub Touch_FrameReported(ByVal sender As Object, ByVal e As TouchFrameEventArgs)
        Dim points = e.GetTouchPoints(Me.ContentPanel)
        Dim position = points(0).Position

        For Each point In points

            Select Case point.Action
                Case TouchAction.Down, TouchAction.Move
                    CreateAndMoveEllipse(point)
                Case TouchAction.Up
                    RemoveEllipse(point)
            End Select
        Next
    End Sub

    Private Sub RemoveEllipse(ByVal touchPoint As TouchPoint)
        Dim id As Integer = touchPoint.TouchDevice.Id
        If Me.ellipses.ContainsKey(id) Then
            Me.ContentPanel.Children.Remove(Me.ellipses(id))
            Me.ellipses.Remove(id)
        End If
    End Sub

    Private ellipses As New Dictionary(Of Integer, Ellipse)

    Private Sub CreateAndMoveEllipse(ByVal touchpoint As TouchPoint)
        Dim id As Integer = touchpoint.TouchDevice.Id
        If Not Me.ellipses.ContainsKey(id) Then
            Me.ellipses.Add(id, New Ellipse With
                            {
                                .Width = 100,
                                .Height = 100,
                                .Fill = Me.GetRandomColor()
                            })
        End If

        Dim ellipse = Me.ellipses(id)

        Canvas.SetTop(ellipse, touchpoint.Position.Y - 50)
        Canvas.SetLeft(ellipse, touchpoint.Position.X - 50)

        If Not ContentPanel.Children.Contains(ellipse) Then
            ContentPanel.Children.Add(ellipse)
        End If
    End Sub

    Private random As New Random()

    Private Function GetRandomColor() As Brush
        Dim brushColor = Color.FromArgb(
            255,
            Convert.ToByte(random.Next(0, 255)),
            Convert.ToByte(random.Next(0, 255)),
            Convert.ToByte(random.Next(0, 255)))

        Return New SolidColorBrush(brushColor)
    End Function
End Class