﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ASPItalia.Books.Chapter13.Server
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Send(PushNotification notification)
        {
            Uri uri = new Uri(this.uri.Text);

            PushNotificationSender sender = new PushNotificationSender();
            PushNotificationResponse response = sender.Send(uri, notification);

            MessageBox.Show(response.NotificationStatus.ToString());
        }

        private void sendButton_Click(object s, EventArgs e)
        {
            Send(new ToastPushNotification
            {
                Text1 = this.text1.Text,
                Text2 = this.text2.Text,
                NotificationClass = NotificationClass.Within900Seconds,
            });
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Send(new TilePushNotification
            {
                Count = 1,
                Title = this.text1.Text,
                BackgroundImage = new Uri( this.text2.Text, UriKind.RelativeOrAbsolute),
                NotificationClass = NotificationClass.Immediately,
            });
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Send(new RawPushNotification
            {
                Data = Encoding.UTF8.GetBytes(this.text1.Text),
                NotificationClass = NotificationClass.Immediately,
            });
        }
    }
}
