﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.IO;
using System.Xml.Linq;
using System.Xml;

namespace ASPItalia.Books.Chapter13.Server
{
    /// <summary>
    /// Rappresent a toast push notification
    /// </summary>
    public class ToastPushNotification : PushNotification
    {
        /// <summary>
        /// Gets or sets the text1.
        /// </summary>
        /// <value>The text1.</value>
        public String Text1 { get; set; }

        /// <summary>
        /// Gets or sets the text2.
        /// </summary>
        /// <value>The text2.</value>
        public String Text2 { get; set; }

        internal override void PrepareHeader(System.Net.WebHeaderCollection headers)
        {
            base.PrepareHeader(headers);

            //headers[HttpRequestHeader.ContentType] = "text/xml";
            headers["X-WindowsPhone-Target"] = "toast";
            headers["X-NotificationClass"] = (((int)this.NotificationClass) + 1).ToString();
        }

        internal override byte[] GetPostData()
        {
            XDocument toastXml = new XDocument(new XDeclaration("1.0", "utf-8", "no"),
               new XElement(WPNotificationNamespace + "Notification",
                   new XElement(WPNotificationNamespace + "Toast",
                       new XElement(WPNotificationNamespace + "Text1", this.Text1 ?? String.Empty),
                       new XElement(WPNotificationNamespace + "Text2", this.Text2 ?? String.Empty))));

            return WriteXml(toastXml);
        }
    }
}
