﻿Imports System.Collections.Generic
Imports System.Linq
Imports System.Text

Public Class PushNotificationResponse

    Friend Sub New(ByVal messageId As Guid, ByVal notificationStatus As NotificationStatus, ByVal deviceConnectionStatus As DeviceConnectionStatus, ByVal subscriptionStatus As SubscriptionStatus)
        Me.MessageID = messageId
        Me.NotificationStatus = notificationStatus
        Me.DeviceConnectionStatus = deviceConnectionStatus
        Me.SubscriptionStatus = subscriptionStatus
    End Sub

    ''' <summary>
    ''' The optional custom header X-MessageID uniquely identifies a notification message.
    ''' </summary>
    Public Property MessageID() As Guid
        Get
            Return m_MessageID
        End Get
        Private Set(ByVal value As Guid)
            m_MessageID = value
        End Set
    End Property
    Private m_MessageID As Guid

    ''' <summary>
    ''' Gets or sets the notification status.
    ''' </summary>
    ''' <value>The notification status.</value>
    Public Property NotificationStatus() As NotificationStatus
        Get
            Return m_NotificationStatus
        End Get
        Private Set(ByVal value As NotificationStatus)
            m_NotificationStatus = value
        End Set
    End Property
    Private m_NotificationStatus As NotificationStatus

    ''' <summary>
    ''' Gets or sets the device connection status.
    ''' </summary>
    ''' <value>The device connection status.</value>
    Public Property DeviceConnectionStatus() As DeviceConnectionStatus
        Get
            Return m_DeviceConnectionStatus
        End Get
        Private Set(ByVal value As DeviceConnectionStatus)
            m_DeviceConnectionStatus = value
        End Set
    End Property
    Private m_DeviceConnectionStatus As DeviceConnectionStatus

    ''' <summary>
    ''' Gets or sets the subscription status.
    ''' </summary>
    ''' <value>The subscription status.</value>
    Public Property SubscriptionStatus() As SubscriptionStatus
        Get
            Return m_SubscriptionStatus
        End Get
        Private Set(ByVal value As SubscriptionStatus)
            m_SubscriptionStatus = value
        End Set
    End Property
    Private m_SubscriptionStatus As SubscriptionStatus

End Class

Public Enum NotificationStatus
    ''' <summary>
    ''' Unkown status
    ''' </summary>
    Unknown
    ''' <summary>
    ''' The notification request was accepted and queued for delivery.
    ''' </summary>
    Received
    ''' <summary>
    ''' The notification has refused.
    ''' </summary>
    Dropped
    ''' <summary>
    ''' Queue overflow. The web service should re-send the notification later. A best practice is to use an exponential backoff algorithm in minute increments.
    ''' </summary>
    QueueFull
    ''' <summary>
    ''' The push notification was received and dropped by the Push Notification Service. The Suppressed status can occur if the notification channel was configured to suppress push notifications for a particular push notification class.
    ''' </summary>
    Suppressed
End Enum

Public Enum DeviceConnectionStatus
    ''' <summary>
    ''' Unkown status
    ''' </summary>
    Unknown
    Connected
    InActive
    Disconnected
    TempDisconnected
End Enum

Public Enum SubscriptionStatus
    ''' <summary>
    ''' Unkown status
    ''' </summary>
    Unknown
    ''' <summary>
    ''' Subscription is valid
    ''' </summary>
    Active
    ''' <summary>
    ''' The subscription is invalid and is not present on the Push Notification Service
    ''' </summary>
    Expired
End Enum