﻿Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Net
Imports System.Xml.Linq
Imports System.IO

''' <summary>
''' Rappresent a tile notification
''' </summary>
Public Class TilePushNotification
    Inherits PushNotification
    ''' <summary>
    ''' Gets or sets the background image. If the uri references a remote resource, the maximum allowed size of the tile image is 80 KB, with a maximum download time of 1 minute. If the tile image size is too large or the download time is greater than 1 minute, the default tile of your application will be displayed instead.
    ''' </summary>
    ''' <value>The background image.</value>
    Public Property BackgroundImage() As Uri
        Get
            Return m_BackgroundImage
        End Get
        Set(ByVal value As Uri)
            m_BackgroundImage = value
        End Set
    End Property
    Private m_BackgroundImage As Uri

    ''' <summary>
    ''' Gets or sets the count number to display.
    ''' </summary>
    ''' <value>The count.</value>
    Public Property Count() As Int32
        Get
            Return m_Count
        End Get
        Set(ByVal value As Int32)
            m_Count = value
        End Set
    End Property
    Private m_Count As Int32

    ''' <summary>
    ''' Gets or sets the title to display.
    ''' </summary>
    ''' <value>The title.</value>
    Public Property Title() As [String]
        Get
            Return m_Title
        End Get
        Set(ByVal value As [String])
            m_Title = value
        End Set
    End Property
    Private m_Title As [String]

    Friend Overrides Sub PrepareHeader(ByVal headers As System.Net.WebHeaderCollection)
        MyBase.PrepareHeader(headers)

        'headers[HttpRequestHeader.ContentType] = "text/xml";
        headers("X-WindowsPhone-Target") = "token"
        headers("X-NotificationClass") = CInt(Me.NotificationClass).ToString()
    End Sub

    Friend Overrides Function GetPostData() As Byte()
        Dim tileXml As New XDocument(New XDeclaration("1.0", "utf-8", "no"), New XElement(WPNotificationNamespace + "Notification", New XElement(WPNotificationNamespace + "Tile", New XElement(WPNotificationNamespace + "BackgroundImage", Me.BackgroundImage), New XElement(WPNotificationNamespace + "Count", Me.Count), New XElement(WPNotificationNamespace + "Title", Me.Title))))

        Return WriteXml(tileXml)
    End Function
End Class