﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;

namespace ASPItalia.Books.Chapter14
{
  public class BoolToValueConverter<T> : IValueConverter
  {
    public T FalseValue { get; set; }
    public T TrueValue { get; set; }

    public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
    {
      T returnValue;
      if (value == null)
      {
        returnValue = FalseValue;
      }
      else
      {
        bool innerValue = (bool)value;
        if (innerValue)
        {
          returnValue = TrueValue;
        }
        else
        {
          returnValue = FalseValue;
        }
      }
      return returnValue;
    }

    public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
    {
      if (value != null)
      {
        return value.Equals(TrueValue);
      }
      else
      {
        return false;
      }
    }
  }

  public class BoolToVisibilityConverter : BoolToValueConverter<Visibility> { }
}
