﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using Microsoft.Phone.Marketplace;
using Microsoft.Phone.Shell;

namespace ASPItalia.Books.Chapter14
{
  public class LicenseManager : IApplicationService, INotifyPropertyChanged
  {
    public LicenseManager()
    {
      if (PhoneApplicationService.Current == null) return;

      PhoneApplicationService.Current.Launching += new EventHandler<LaunchingEventArgs>(Current_Launching);
      PhoneApplicationService.Current.Activated += new EventHandler<ActivatedEventArgs>(Current_Activated);
    }

    private void ReloadLicense()
    {
      IsTrial = new LicenseInformation().IsTrial();
    }

    private void Current_Activated(object sender, ActivatedEventArgs e)
    {
      if (!IsDebugTrial)
        ReloadLicense();
    }

    private void Current_Launching(object sender, LaunchingEventArgs e)
    {
      if (!IsDebugTrial)
        ReloadLicense();
    }

    public void StartService(ApplicationServiceContext context)
    {
      Current = this;
    }

    public void StopService() { }

    public static LicenseManager Current { get; private set; }

    private bool _isTrial;
    public bool IsTrial
    {
      get { return _isTrial; }
      private set
      {
        if (_isTrial != value)
        {
          _isTrial = value;
          NotifyPropertyChanged("IsTrial");
        }
      }
    }

    private bool _isDebugTrial;
    public bool IsDebugTrial
    {
      get { return _isDebugTrial; }
      set
      {
        if (_isDebugTrial != value)
        {
          _isDebugTrial = value;
          if (_isDebugTrial)
            IsTrial = true;
        }
      }
    }

    public event PropertyChangedEventHandler PropertyChanged;
    private void NotifyPropertyChanged(string propertyName)
    {
      if (PropertyChanged != null)
        PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
    }
  }

  //public class LicenseManager : IApplicationService, INotifyPropertyChanged
  //{
  //  public LicenseManager()
  //  {
  //  }

  //  public void StartService(ApplicationServiceContext context)
  //  {
  //    Current = this;
  //    IsTrial = new LicenseInformation().IsTrial();
  //  }

  //  public void StopService() { }

  //  public static LicenseManager Current { get; private set; }

  //  private bool _isTrial;
  //  public bool IsTrial
  //  {
  //    get { return _isTrial; }
  //    private set
  //    {
  //      if (_isTrial != value)
  //      {
  //        _isTrial = value;
  //        NotifyPropertyChanged("IsTrial");
  //      }
  //    }
  //  }

  //  #region INotifyPropertyChanged
  //  public event PropertyChangedEventHandler PropertyChanged;
  //  private void NotifyPropertyChanged(string propertyName)
  //  {
  //    if (PropertyChanged != null)
  //      PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
  //  }
  //  #endregion
  //}
}
