﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Microsoft.Phone.Info;

namespace ASPItalia.Books.Chapter14
{
  public class MainData : INotifyPropertyChanged
  {
    public const string STORAGE_FILENAME = "MainData.dat";

    private Note _currentNote;
    public Note CurrentNote
    {
      get
      {
        if (_currentNote == null)
        {
          _currentNote = new Note();
        }
        return _currentNote;
      }
      set
      {
        _currentNote = value;
        NotifyPropertyChanged("CurrentNote");
      }
    }

    private ObservableCollection<Note> _allNotes;
    public ObservableCollection<Note> AllNotes
    {
      get
      {
        if (_allNotes == null)
        {
          _allNotes = new ObservableCollection<Note>();
        }
        return _allNotes;
      }
    }

public LicenseManager License
{
  get { return LicenseManager.Current; }
}

    public event PropertyChangedEventHandler PropertyChanged;
    private void NotifyPropertyChanged(string propertyName)
    {
      if (PropertyChanged != null)
        PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
    }
  }

  public class Note : INotifyPropertyChanged
  {
    private string _text;
    public string Text
    {
      get { return _text; }
      set
      {
        _text = value;
        NotifyPropertyChanged("Text");
      }
    }

    private bool _isSpecial;
    public bool IsSpecial
    {
      get { return _isSpecial; }
      set
      {
        _isSpecial = value;
        NotifyPropertyChanged("IsSpecial");
      }
    }

    public event PropertyChangedEventHandler PropertyChanged;
    private void NotifyPropertyChanged(string propertyName)
    {
      if (PropertyChanged != null)
        PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
    }

    public override string ToString()
    {
      return Text;
    }
  }

  public class Util
  {
    public static T GetDeviceExt<T>(string properties)
    {
      T _result = default(T);
      object _value = null;

      if (DeviceExtendedProperties.TryGetValue(properties, out _value))
        _result = (T)_value;

      return _result;
    }

    public static T GetUserExt<T>(string properties)
    {
      T _result = default(T);
      object _value = null;

      if (UserExtendedProperties.TryGetValue(properties, out _value))
        _result = (T)_value;

      return _result;
    }
  }
}
