﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Windows.Data;
using System.ComponentModel;
using System.Diagnostics;

namespace ASPItalia.Books.Chapter14
{
  public partial class SecondPage : PhoneApplicationPage
  {
    CollectionViewSource _viewSource;

    public SecondPage()
    {
      InitializeComponent();

      Debug.WriteLine("costruttore Pagina2");
    }

    private void LoadData()
    {
      if (_viewSource != null) return;

      _viewSource = new CollectionViewSource();

      MainData _mainData = (Application.Current.RootVisual as PhoneApplicationFrame).DataContext as MainData;

      if (_mainData == null) return;

      _viewSource.Source = _mainData.AllNotes;
      ICollectionView collectionView = _viewSource.View;
      collectionView.Filter = n => ((Note)n).IsSpecial == viewOnlySpecial.IsChecked.Value;

      NotesList.ItemsSource = collectionView;
    }

    private void viewOnlySpecial_Checked(object sender, RoutedEventArgs e)
    {
      if (_viewSource != null)
        _viewSource.View.Refresh();
    }

    private void viewOnlySpecial_Unchecked(object sender, RoutedEventArgs e)
    {
      if (_viewSource != null)
        _viewSource.View.Refresh();
    }

    protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
    {
      Debug.WriteLine("OnNavigatedTo Pagina2");

      LoadData();

      if (State.ContainsKey("viewOnlySpecial"))
        viewOnlySpecial.IsChecked = State["viewOnlySpecial"] as bool?;

      base.OnNavigatedTo(e);
    }

    protected override void OnNavigatedFrom(System.Windows.Navigation.NavigationEventArgs e)
    {
      Debug.WriteLine("OnNavigatedFrom Pagina2");

      if (State.ContainsKey("viewOnlySpecial"))
        State.Remove("viewOnlySpecial");

      State.Add("viewOnlySpecial", viewOnlySpecial.IsChecked);

      base.OnNavigatedFrom(e);
    }
  }
}