﻿Imports System.Windows.Data

Public Class BoolToValueConverter(Of T)
  Implements IValueConverter
  Public Property FalseValue() As T
    Get
      Return m_FalseValue
    End Get
    Set(ByVal value As T)
      m_FalseValue = value
    End Set
  End Property
  Private m_FalseValue As T
  Public Property TrueValue() As T
    Get
      Return m_TrueValue
    End Get
    Set(ByVal value As T)
      m_TrueValue = value
    End Set
  End Property
  Private m_TrueValue As T

  Public Function Convert(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.Convert
    Dim returnValue As T
    If value Is Nothing Then
      returnValue = FalseValue
    Else
      Dim innerValue As Boolean = CBool(value)
      If innerValue Then
        returnValue = TrueValue
      Else
        returnValue = FalseValue
      End If
    End If
    Return returnValue
  End Function

  Public Function ConvertBack(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.ConvertBack
    If value IsNot Nothing Then
      Return value.Equals(TrueValue)
    Else
      Return False
    End If
  End Function
End Class

Public Class BoolToVisibilityConverter
  Inherits BoolToValueConverter(Of Visibility)
End Class
