﻿Imports Microsoft.Phone.Marketplace
Imports System.ComponentModel

Public Class LicenseManager
  Implements IApplicationService
  Implements INotifyPropertyChanged

  Public Sub New()
    If (Not PhoneApplicationService.Current Is Nothing) Then
      AddHandler PhoneApplicationService.Current.Launching, _
        New EventHandler(Of LaunchingEventArgs)(AddressOf Me.Current_Launching)
      AddHandler PhoneApplicationService.Current.Activated, _
        New EventHandler(Of ActivatedEventArgs)(AddressOf Me.Current_Activated)
    End If
  End Sub

  Private Sub ReloadLicense()
    IsTrial = New LicenseInformation().IsTrial()
  End Sub

  Private Sub Current_Activated(ByVal sender As Object, ByVal e As ActivatedEventArgs)
    If Not IsDebugTrial Then
      ReloadLicense()
    End If
  End Sub

  Private Sub Current_Launching(ByVal sender As Object, ByVal e As LaunchingEventArgs)
    If Not IsDebugTrial Then
      ReloadLicense()
    End If
  End Sub

  Public Sub StartService(ByVal context As ApplicationServiceContext) _
    Implements IApplicationService.StartService
    Current = Me
  End Sub

  Public Sub StopService() Implements IApplicationService.StopService
  End Sub

  Public Shared Property Current() As LicenseManager
    Get
      Return m_Current
    End Get
    Private Set(ByVal value As LicenseManager)
      m_Current = value
    End Set
  End Property
  Private Shared m_Current As LicenseManager

  Private _isTrial As Boolean
  Public Property IsTrial() As Boolean
    Get
      Return _isTrial
    End Get
    Private Set(ByVal value As Boolean)
      If _isTrial <> value Then
        _isTrial = value
        NotifyPropertyChanged("IsTrial")
      End If
    End Set
  End Property

  Private _isDebugTrial As Boolean
  Public Property IsDebugTrial() As Boolean
    Get
      Return _isDebugTrial
    End Get
    Set(ByVal value As Boolean)
      If _isDebugTrial <> value Then
        _isDebugTrial = value
        If _isDebugTrial Then
          IsTrial = True
        End If
      End If
    End Set
  End Property

  Public Event PropertyChanged As PropertyChangedEventHandler _
    Implements INotifyPropertyChanged.PropertyChanged

  Private Sub NotifyPropertyChanged(ByVal info As String)
    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(info))
  End Sub
End Class

