﻿Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Ink
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports System.ComponentModel
Imports System.Collections.ObjectModel
Imports Microsoft.Phone.Info

Public Class MainData
  Implements INotifyPropertyChanged

  Public Const STORAGE_FILENAME As String = "MainData.dat"

  Private _currentNote As Note
  Public Property CurrentNote() As Note
    Get
      If _currentNote Is Nothing Then
        _currentNote = New Note()
      End If
      Return _currentNote
    End Get
    Set(ByVal value As Note)
      _currentNote = value
      NotifyPropertyChanged("CurrentNote")
    End Set
  End Property

  Private _allNotes As ObservableCollection(Of Note)
  Public ReadOnly Property AllNotes() As ObservableCollection(Of Note)
    Get
      If _allNotes Is Nothing Then
        _allNotes = New ObservableCollection(Of Note)()
      End If
      Return _allNotes
    End Get
  End Property

  Public ReadOnly Property License() As LicenseManager
    Get
      Return LicenseManager.Current
    End Get
  End Property

  Public Event PropertyChanged As PropertyChangedEventHandler _
    Implements INotifyPropertyChanged.PropertyChanged

  Private Sub NotifyPropertyChanged(ByVal info As String)
    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(info))
  End Sub
End Class

Public Class Note
  Implements INotifyPropertyChanged
  Private _text As String
  Public Property Text() As String
    Get
      Return _text
    End Get
    Set(ByVal value As String)
      _text = value
      NotifyPropertyChanged("Text")
    End Set
  End Property

  Private _isSpecial As Boolean
  Public Property IsSpecial() As Boolean
    Get
      Return _isSpecial
    End Get
    Set(ByVal value As Boolean)
      _isSpecial = value
      NotifyPropertyChanged("IsSpecial")
    End Set
  End Property

  Public Event PropertyChanged As PropertyChangedEventHandler _
    Implements INotifyPropertyChanged.PropertyChanged

  Private Sub NotifyPropertyChanged(ByVal info As String)
    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(info))
  End Sub

  Public Overrides Function ToString() As String
    Return Text
  End Function
End Class

Public Class Util
  Public Shared Function GetDeviceExt(Of T)(ByVal properties As String) As T
    Dim _result As T = Nothing
    Dim _value As Object = Nothing

    If DeviceExtendedProperties.TryGetValue(properties, _value) Then
      _result = DirectCast(_value, T)
    End If

    Return _result
  End Function

  Public Shared Function GetUserExt(Of T)(ByVal properties As String) As T
    Dim _result As T = Nothing
    Dim _value As Object = Nothing

    If UserExtendedProperties.TryGetValue(properties, _value) Then
      _result = DirectCast(_value, T)
    End If

    Return _result
  End Function

End Class

